/*
 * Jalview - A Sequence Alignment Editor and Viewer ($$Version-Rel$$)
 * Copyright (C) $$Year-Rel$$ The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.datamodel;

import static org.testng.AssertJUnit.assertEquals;

import org.testng.annotations.Test;

public class MappingTypeTest
{

  @Test(groups = "Functional")
  public void testGetFromRatio()
  {
    /*
     * nucleotide-nucleotide
     */
    assertEquals(1, MappingType.GenomeToCdna.getFromRatio());
    assertEquals(1, MappingType.CdnaToGenome.getFromRatio());
    assertEquals(1, MappingType.GenomeToCds.getFromRatio());
    assertEquals(1, MappingType.CdsToGenome.getFromRatio());
    assertEquals(1, MappingType.CdnaToCds.getFromRatio());
    assertEquals(1, MappingType.CdsToCdna.getFromRatio());

    /*
     * nucleotide-peptide
     */
    assertEquals(3, MappingType.GenomeToPeptide.getFromRatio());
    assertEquals(1, MappingType.PeptideToGenome.getFromRatio());
    assertEquals(3, MappingType.CdnaToPeptide.getFromRatio());
    assertEquals(1, MappingType.PeptideToCdna.getFromRatio());
    assertEquals(3, MappingType.CdsToPeptide.getFromRatio());
    assertEquals(1, MappingType.PeptideToCds.getFromRatio());
  }

  @Test(groups = "Functional")
  public void testGetToRatio()
  {
    /*
     * nucleotide-nucleotide
     */
    assertEquals(1, MappingType.GenomeToCdna.getToRatio());
    assertEquals(1, MappingType.CdnaToGenome.getToRatio());
    assertEquals(1, MappingType.GenomeToCds.getToRatio());
    assertEquals(1, MappingType.CdsToGenome.getToRatio());
    assertEquals(1, MappingType.CdnaToCds.getToRatio());
    assertEquals(1, MappingType.CdsToCdna.getToRatio());

    /*
     * nucleotide-peptide
     */
    assertEquals(1, MappingType.GenomeToPeptide.getToRatio());
    assertEquals(3, MappingType.PeptideToGenome.getToRatio());
    assertEquals(1, MappingType.CdnaToPeptide.getToRatio());
    assertEquals(3, MappingType.PeptideToCdna.getToRatio());
    assertEquals(1, MappingType.CdsToPeptide.getToRatio());
    assertEquals(3, MappingType.PeptideToCds.getToRatio());
  }
}
